//+------------------------------------------------------------------+
//|                                                     	CommentTab |
//|         			 				 |
//|														- Meat 																 |
//|      +    					 |
//|  +      CommentTab 							 |
//|														- Alexey Sergeev (profy.mql@gmail.com) |
//+------------------------------------------------------------------+

#import "Gdi32.dll"
	int CreateFontA(int nHeight, int nWidth, int nEscapement, int nOrientation, int fnWeight, int fdwItalic, int fdwUnderline, int fdwStrikeOut, int fdwCharSet, int fdwOutputPrecision, int fdwClipPrecision, int fdwQuality, int fdwPitchAndFamily, string lpszFace);
	int SelectObject(int hdc, int hgdiobj);
	bool DeleteObject(int hObject);
	bool GetTextExtentPoint32A(int hdc, string lpString, int cbString, int lpSize[]);
#import "user32.dll"
	int GetDC(int hWnd); 
	int ReleaseDC(int hWnd,int hDC);
#import

#define DEFAULT_CHARSET 		1
#define OUT_DEFAULT_PRECIS 	0
#define CLIP_DEFAULT_PRECIS	0
#define DEFAULT_QUALITY			0
#define DEFAULT_PITCH			0
#define FF_MODERN					48

//------------------------------------------------------------------	start
int start()
{
  string txt="\n";
  txt=txt+"Ticket\tOpen Time\tType\tSize\tItem\tPrice\tS / L\tT / P\tClose Time\tPrice\tCommission\tTaxes\tSwap\tProfit"+"\n";
  txt=txt+"524567\t28.06.2011 15:02\tbuy\t0.35\teurusd.vpe\t1.43380\t1.43390\t0.00000\t29.06.2011 2:39\t1.43383\t-3.50\t0.00\t0.56\t0.73"+"\n";
  txt=txt+"523492\t28.06.2011 15:02\tbuy\t0.70\teurusd.vpe\t1.43397\t1.43407\t1.47115\t28.06.2011 18:17\t1.43407\t-7.00\t0.00\t0.00\t4.88"+"\n";
  txt=txt+"523494\t28.06.2011 15:02\tbuy\t0.70\teurusd.vpe\t1.43397\t1.43407\t0.00000\t28.06.2011 18:17\t1.43407\t-7.00\t0.00\t0.00\t4.88"+"\n";
  txt=txt+"523498\t28.06.2011 15:02\tbuy\t0.35\teurusd.vpe\t1.43380\t1.43390\t0.00000\t28.06.2011 17:00\t1.43675\t-3.50\t0.00\t0.00\t71.86"+"\n";
  txt=txt+"522650\t27.06.2011 14:50\tbuy\t0.80\teurusd.vpe\t1.42240\t1.42371\t1.43687\t28.06.2011 15:19\t1.43693\t-8.00\t0.00\t1.28\t808.95"+"\n";
  
  int tab[]={15, 30, 13, 15, 19, 15, 15, 15, 28, 15, 25, 15, 15}; //   
  	
	CommentTab(txt, tab, 30); //    
}
//------------------------------------------------------------------	CommentTab
void CommentTab(string txtIn, int tab[], int tabdef)
{
  int hWnd=WindowHandle(Symbol(),Period()); //   
  int hdc=GetDC(hWnd); //  
  int fontsize=7;
  int fontheight=MathRound(fontsize*96/72.0); //       
  //   
  string font="Tahoma";
  int hFont=CreateFontA(-fontheight, 0, 0, 0, 0, 0, 0, 0, DEFAULT_CHARSET, OUT_DEFAULT_PRECIS, CLIP_DEFAULT_PRECIS, DEFAULT_QUALITY, DEFAULT_PITCH|FF_MODERN, font); 
  SelectObject(hdc, hFont); //       
  
	int size[2];
	GetTextExtentPoint32A(hdc, " ", 1, size); //    - 
	int xSpace=size[0]; if (xSpace==0) { Print("-err xSpace==0!"); return(0); }
	string txtOut="", txtLine="";
	int xTab=0; //     
	int nTab=0; //      tab
	int n=StringLen(txtIn); //  
	for (int i=0; i<n; i++)
	{
		int ch=StringGetChar(txtIn, i); //  
		if (ch!='\t') txtLine=txtLine+CharToStr(ch); //       (   )
		if (ch=='\n' || i==n-1) { txtOut=txtOut+txtLine; txtLine=""; xTab=0; nTab=0; continue; } //      ,    
		if (ch=='\t') //   
		{
			GetTextExtentPoint32A(hdc, txtLine, StringLen(txtLine), size);  //     size
			
			if (nTab<ArraySize(tab)) xTab+=tab[nTab]*xSpace; else xTab+=tabdef*xSpace; //   
			nTab++; //    
			int tt=size[0]*1.0/xTab; //     
			while (tt>0)
			{
				if (nTab<ArraySize(tab)) xTab+=tab[nTab]*xSpace; else xTab+=tabdef*xSpace; //   
				nTab++; //    
				tt=size[0]*1.0/xTab; //     
			}
			
			int t=tt+1; //   1   
			while (tt<t) //  ,       
			{
				txtLine=txtLine+" "; 
				GetTextExtentPoint32A(hdc, txtLine, StringLen(txtLine), size);  //     size
				tt=size[0]*1.0/xTab;
			} 
		}
  }
  Comment(txtOut); //  
	ReleaseDC(hWnd, hdc); //  
	DeleteObject(hFont); //  
	return(0);
}